/*
   Calculate the average of a float array's elements.
 */

#include <stdlib.h>
#include <stdio.h>

#include <altivec.h>

#include "data.h"

float avg(float *input, int num)
{
    int i;
    float res;
    float scale = 1.0 / num;
    vector float vres   = {0, 0, 0, 0};
    vector float vscale = {scale, scale, scale, scale};

    for (i = 0; i < num - 4; i += 4) {
        vector float *current = ((vector float *)&input[i]);
        vres = vec_add(vres, vec_mul(*current, vscale));
    }
    res = vres[0] + vres[1] + vres[2] + vres[3];
    for (; i < num; i++) {
        res += input[i] * scale;
    }
    return res;
}

int main(int argc, char *argv[])
{
	printf("avg = %f\n", avg(data, data_len));
	return 0;
}
