/*
   See how endianness influences your result when doing
   a reinterpretation cast of vector registers.
 */
#include <stdio.h>

#include <altivec.h>

int main(int argc, char *argv[])
{
	vector unsigned int va = {0x11, 0x22, 0x33, 0x44};
	vector unsigned short vb = (vector unsigned short)va;

	printf("vb = {0x%X, 0x%X, 0x%X, 0x%X, 0x%X, 0x%X, 0x%X, 0x%X}\n", 
			vb[0], vb[1], vb[2], vb[3], vb[4], vb[5], vb[6], vb[7]);
	
	return 0;
}
